
#ifndef MAIN_HEADER  //Prevents multiple includes
#define MAIN_HEADER

#define USE_ERROR_FLAG			0 
#define USE_TOGGLE_FLAG			0

//TickCounter  MUSS SEIN !!!
#define TIMER0_USED				0 		
#define TIMER1_USED				0
#define TIMER2_TICK_USED		1	
#define UART_USE_ENABLED		0
#define EEPROM_USED				0
#define STEPMOTOR_USED  		0			//#if STEPMOTOR_USED  == 1
#define ADC_USED_ENABLED		0
#define FRQ_SYNT_T1_USED		1
#define LIGHT_POS_USED			1
#define TEXT_SERVICE_USE_ENABLED		0

//sfr |= _BV(bit)  ---  sfr &= ~(_BV(bit))
#define UART_ERRORMSG					0
//#define MSG							0
#define LCD_4Bit_Module_USED			0
#define LCD_MSG_USED					0 //Never  forget, PB3 ist mit 10K pulldown zu schalten
//Timeout von LCD wird simuliert
#define COM_TX_ENABLED					0
#define LCD_MENUE_USED					0
#define ENDORDER_CMD_ECHO_ENABLED	1
//TWI


/*
REGISTER = WERT;
sbi (PORTB, 2);   // Setzt Pin 2 auf Logisch 1 (EIN)
cbi (PORTB, 2);   // Setzt Pin 2 auf Logisch 0 (AUS)
PIN
X = PORT // inp (PINB)--> bPortD = inp (PIND);

Wobei es hier sehr wichtig ist, als Portadresse nicht etwa das
Portregister PORTx zu verwenden,sondern die Porteingangsadresse PINx.
Dies ist ein oft gemachter Fehler!
*/


/*
Jedes Port hat drei Register
DDxN
PORTXn
PINxn
IF PortX ist INPUT an PORTX= set to 1, PullUP IS ENABLED
*/


/*
Text verbraucht Speicher
Statt Pointer geht evtl auch diese Form
TESTEN !!!
const uint8_t MCA_CRLFSTR[] __attribute__ ((section (".text"))) = {13,10,0};
//Versus diesr Form, die Speicher verbraucht !! ROCKEN ALS EINFGESTRING DEFINIERT.
#define MCA_CRLFSTR (const char){CR,LF,0}  //redefined 

*/


//For compatibility for OLDER Compilers
//#define	sbi(sfr, bit)   (_SFR_BYTE(sfr) |= _BV(bit))
//#define	cbi(sfr, bit)   (_SFR_BYTE(sfr) &= ~_BV(bit))


#define STRMAX 32
#define NUMMAX 12
#define RX_STRMAX 32

#define DELIMITER		','
#define DELIMITERSTR	","
#define COMAMNDSIZEMAX  10 //0Zehn Commands

#define BYTE_LIMIT 255				//uint8_t					uint8_t
#define WORD_LIMIT 65535			//unsigned short				uint16_t
#define DWORD_LIMIT 4294967295UL	//unsigned long					uint32_t
//Wird benutz um T2 berlauf zu berwachen !!
#define BEFORE_DWORD_LIMIT 429496000UL	//unsigned long					uint32_t
#define QWORD_LIMIT 18446744073709551615ULL	//unsigned long long 	uint64_t

#define LOW_NIPPEL_MASK		0x0F
#define HIGH_NIPPEL_MASK	0xF0

//TYPEN DEKLARATION
typedef struct
	{
	float fStepMot_FRQ;	
	float fRampeFrq;		//Wird incrementiert bis == gsStMPar.fStepMot_FRQ fr Rampe	
	uint8_t ucSM_Mode;	//Full=1 Half  = 2
	uint32_t ulMovedSteps;//compare with MovedSteps //Wieviel hat sich der Motor gedreht..		
	uint32_t ulSM_ToRunCnt;	//PULSE die der Motor laufen soll	
	uint8_t ucStepMot_RampRise;
	
	uint16_t uiSM_MotorStepsRotationType; //=PREFDEF_STEPS_PER_ROTATION
	uint16_t uiStepsPerRotation; //ucSM_Mode * uiSM_MotorStepsRotationType=PREFDEF_STEPS_PER_ROTATION= 
	uint8_t ucStepMConditionFlag;	//ISTZUSTAND wir Mode
	uint8_t ucSM_PostionFlag;
}STEPMPARTYPE;	//gsStMPar.

//Tastatur
typedef struct
	{
	uint32_t ulEventTime;	//offen/geschlossen Zeit des Schalter fr Debounce
	uint8_t ucKeyStat;		//Status, Fr das Speichern des Status der Taste
	uint8_t ucKey;			// Tasten
	}KEYSTRUCT_TYPE;


typedef struct
	{
	uint8_t ucaCmd[COMAMNDSIZEMAX +1];
	uint8_t ucCmdID;
	float fCmdVal_1;
	float fCmdVal_2;
//uint8_t ucCmdID;
	}COMMAND_TYPE;


typedef struct
	{	
	uint8_t ucaInEEPROMStr[12];	//Fr strlen( EEPROMVALID) = 11 + 1
	}EEPROM_STR_TYPE;	



/*
typedef struct
	{	
	uint8_t ucaInEEPROMStr[12];	//Fr strlen( EEPROMVALID) = 11 + 1
	}EEPROM_STR_TYPE;	
*/

//TTT
// Hardwareassignment
//#define           11059200L Hz   
//F_CPU  in makefile !!!
//CPU = 16000000L
#define SYSCLK			F_CPU
#define UART_BAUD_RATE	9600	/* 9600 baud */
//SYSCLK/256= 62500
//SYSCLK/64 = 250000
//SYSCLK/1024 =15625     Counts/Sec  !!!!
// Sekunden fr vollen Timerlauf 
// 1/F = 1/16000000  =  0.0000000625   Hz minimal
#define PULS_PER_SECOND_T1	10800 //TCCR2_CLK_1024
#define PULS_PER_SECOND_T2	976.5625	//TCCR2_CLK_64
#define Time_Per_count_T2	0,001024	//   1/Puls_PER_SECOND
	
#define SYSCLK_256	(SYSCLK / 256) // =  62500 //z.B.Timer2 berlauf / 256  / Teilerfaktor


#define DISABLE_ALL_PULLUP_MAC	(SFIOR |= _BV(PUD));
#define ENABLE_ALLUP_SCL_MAC	(SFIOR &= ~(_BV(PUD)));


//DELAY
//#define TCCR2_CLK_64	0x04	//675 = 0,0014814814814814814814814814814815   mS Interrrupt
// 1 TICK = 1.4814814814814814814814814814815 ms 
//NUR UNGEFHR
//BERECHUNG Xtime(ms) / 1.48....
#define TIMEOUT_1_5MS 	1 
#define TIMEOUT_2_9MS 	2
#define TIMEOUT_4_4MS 	3
#define TIMEOUT_10_3MS 	7
#define TIMEOUT_100_7MS	68
#define TIMEOUT_500_7MS	338
#define TIMEOUT_1S 		675		//!!  uint16_t
#define TIMEOUT_5S 		3375	//!!  uint16_t

//REGISTER
#define TCCR0_FAST_PWM	0x48	//Mode 3
#define TCCR0_OC0_MODE	0x20	//Clear ON compare Match
#define TCCR0_OC0_DISCONNECT_MODE	0x00
#define TCCR0_CLK_STOP	0x00	
#define TCCR0_CLK_0		0x01	
#define TCCR0_CLK_8		0x02	
#define TCCR0_CLK_64	0x03	
#define TCCR0_CLK_256	0x04	
#define TCCR0_CLK_1024	0x05	
#define TCCR0_EXT_CLK_FALL_T0	0x06	
#define TCCR0_EXT_CLK_RISE_T0	0x07	

#define TCCR2_WGM_NORMAL		0x00
#define TCCR2_CTC_MODE			0x08 //0000 1000
#define TCCR2_COM_NORMALPORT	0x00
#define TCCR2_CLK_STOP			0x00
#define TCCR2_FASTPWM			0x48	//Mode 3
#define TCCR2_CS_BIST			0x0x	//Mode 3
#define TCCR2_CLK_1024	0x07	
#define TCCR2_CLK_256	0x06	
#define TCCR2_CLK_128	0x05
#define TCCR2_CLK_64	0x04	//
#define TCCR2_CLK_32	0x03
#define TCCR2_CLK_8		0x02	//	1/F = 
#define TCCR2_CLK_0		0x01	
#define TCCR2_CLK_STOP	0x00	
//TIMER2 WIRD BERECHNET /z.B:OverFLow SYSCLK /  256 / TCCR2_CLK_64 =  OVL/Sec
// 1/OVLS = 1/ = 
//-----> 

//#define TCCR1B_CLOCKSEL_CTC1 		0x08	//Clear Timer/Counter  on Compare Match Timer/Counter 1
#define TCCR1B_CLOCKSEL_STOP		0x00	//Clock Select Bits
#define TCCR1B_CTC_MODE				0x08	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1		0x01	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_8		0x02	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_64		0x03	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_256		0x04	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1024	0x05	//Clock Select Bits



//INTERUPT CTRL REG //NICHT mit MCUCSR verwechseln !
#define MCUCR_LOWLEVEL_INT0		0x00	
#define MCUCR_ANYCHANGE_INT0	0x01 //=_BV(ISC01) 	
#define MCUCR_FALLING_EDGE_INT0	0x02	
#define MCUCR_RISING_EDGE_INT0	0x03

#define MCUCR_LOWLEVEL_INT1		0x00	
#define MCUCR_ANYCHANGE_INT1	0x04 //=_BV(ISC10) 	
#define MCUCR_FALLING_EDGE_INT1	0x08	
#define MCUCR_RISING_EDGE_INT1	0x0C

#define GATE_ANYCHANGE_INT1_MODE_MAC	(MCUCR |= MCUCR_ANYCHANGE_INT1)


//Global Interrrupt CTRL REG
#define GICR_INT0_ON_MAC	(GICR |= _BV(INT0)) //_BV(INT0)
#define GICR_INT0_OFF_MAC	(GICR &= ~(_BV(INT0)))
#define GICR_INT1_ON_MAC	(GICR |= _BV(INT1))
#define GICR_INT1_OFF_MAC	(GICR &= ~(_BV(INT1)))
#define GICR_INT_0u1_OFF_MAC	(GICR &= 0x3F)  //SIEHE DATENBLATT


#define RCO_B_INT_ON_MAC	GICR_INT0_ON_MAC 
#define RCO_B_INT_OFF_MAC	GICR_INT0_OFF_MAC
#define GATE_INT1_ON_MAC	GICR_INT1_ON_MAC
#define GATE_INT1_OFF_MAC	GICR_INT1_OFF_MAC


#define OVERFLOW_CNT_ON_INT0_MAC	RCO_B_INT_ON_MAC
#define OVERFLOW_CNT_OFF_INT0_MAC	RCO_B_INT_OFF_MAC

#define GATE_ALL_EVENT_ON_INT1_MAC	GATE_INT1_ON_MAC
#define GATE_ALL_EVENT_OFF_INT1_MAC	GATE_INT1_OFF_MAC

//GIFR  I_FLAG
#define GIFR_INTF0_SET_MAC	(GIFR |= _BV(INTF0)) //_BV(INT0)
#define GIFR_INTF0_CLR_MAC	(GIFR &= ~(_BV(INTF0)))
#define GIFR_INTF1_CLR_MAC	(GIFR |= _BV(INTF1))
#define GIFR_INTF1_SET_MAC	(GIFR &= ~(_BV(INTF1)))
#define GIFR_INTF_0u1_CLR_MAC	(GIFR &= 0x3F) //Siehe Datenblatt = letzten beiden Bits



//PORTB 
#define MOSI_I         3//BIT3
#define MISO_0         4//BIT4
#define SCK_I          5//BIT5

//#define TCCR1B_CLOCKSEL_CTC1 		0x08	//Clear Timer/Counter  on Compare Match Timer/Counter 1
#define TCCR1B_CLOCKSEL_STOP		0x00	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1		0x01	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_8		0x02	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_64		0x03	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_256		0x04	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1024	0x05	//Clock Select Bits



//EEPROM
#define EEPROM_SECTION  __attribute__ ((section (".eeprom")))
#define IEEPROM_SIZE	512	//Interne EEPROM
#define EE_DUMMYLOAD 0x5AA5 //unwahrsch. wert 0101 1010 1010 0101
//If using 8 block by 512 max = 64 Byte/block
//#define IEEPROM_SECTIONSIZE	64   //by 8 Section




//INTERRUPT
#define INTx_INPORT	PIND
//#define INT1_MASK	0x08  //PD3
//#define INT0_MASK	0x04  //PD2
#define INT0_PIN_NR	PD2
#define INT1_PIN_NR	PD3


//PORTB


#define TWI_DIRREG		DDRC
#define TWI_OUT_PORT	PORTC
#define TWI_IN_PORT		PINC
#define TWI_SDA			PC4		//PC4	OUT
#define TWI_SCL			PC5		//PC5	IN

/*
#define Clr_TWI_SDA_MAC	 	TWI_OUT_PORT &= ~PC_SDA_BIT;	 
#define Set_TWI_SDA_MAC	 	TWI_OUT_PORT |= PC_SDA_BIT;	 
#define TWI_SCL_IS_HIGH		(TWI_IN_PORT & PC_SCL_BIT )
#define TWI_SCL_IS_LOW		(!(TWI_IN_PORT & PC_SCL_BIT))
*/


//PORTD TX/RX ERST MAL FR  FLAGS
#define PD0_RX_BIT	0x01	//PIN2
#define PD1_TX_BIT	0x02	//PIN3


#if USE_TOGGLE_FLAG == 1
#define TEST_BIT_DIRREG DDRB
#define TEST_BIT_PORT	PORTB
#define TEST_BIT	0x01 	//
#define SET_TESTBIT_MAC	(TEST_BIT_PORT |= TEST_BIT)
#define CLR_TESTBIT_MAC	(TEST_BIT_PORT &= ~TEST_BIT)
#endif


//========================================================================

//TIMERS
//TIMER2  = is 61 miliseconds Timer ~approx.
// 16MhZ / 1024 / 256  = 61,03515625 Hz
// T= 1/f = 0.016384 ms / Interrupt
#define TIMER2_INT_FREQUENCY	61.03515625
#define TIMER2_INTPERIODE		0.016384 //1/TIMER2_INT_FREQUENCY BY EVERY OVERFLOW = 1 Second!
#define ONE_SECOND_TICKS		61	//1/ TIMER2_INTPERIODE
#define LONG_10DELAY_TICKS		610	//1/ TIMER2_INTPERIODE
#define SM_AFTERSTOPDELAY_TICKS	2	//~16ms 1=TIMER2_INTPERIODE,

//PORT_ASSIGMNEMTS
//Bit usage, use by sbi, cbi

//MACRO
// HARWARE MAKROS

//#define LED_GRUEN_ON_MAC	sbi(LED_PORT, LED_GRUEN);
//#define LED_GRUEN_OFF_MAC	cbi(LED_PORT, LED_GRUEN);

//-----------------------

//MASKENBITS


//FLAG MEANING USED VOR INTERRUPT
/*
BIT 7
BIT 6
BIT 5
BIT 4
BIT 3
BIT 2
BIT 1
BIT 0 = INT0 = 0x01
*/

#define WDTO_2S   7 //WatchDog
//SOFTWARE USED DEFINES


#define ASC_CR	13
#define ASC_LF	10

//COMMAND
#define STXSIZEMAX	3
#define ETX			ASC_CR

#define DELIMITER		','
#define DELIMITERSTR	","


//delay.h 8-bit count, 
//EIn Aufruf von _delay_loop_2 = 4 Cyclen lan = 0.00000025 = 0.250 NanoSecunden
#define OneCycletime	0.0000000625  // 1 / F_CPU
#define DELAYCYCLE_3	0.0000001875 //375ns fr eine Pause //CPU_CYCLE_TIME *3 fr 8 Bit
#define DELAYCYCLE_4 	0.00000025 //500ns fr eine!!! Pause= _delay_loop_2(1); //CPU_CYCLE_TIME *4 fr 16Bit
// 500nS sind 8 * OneCycletime
//1ms= 16000 * OneCycletime
#define DELAY_1NS		4	//4 * 4 Cycles
#define DELAY_1000NS	4000 //()

#define FLOAT_OVERFLOW_2_19 0x7FFFFUL //= liegt VOR berlauf !!! 524287	Um es Vor!! DEM BERLAUF ABZUFANGEN
#define HALF_FLOAT_OVERFLOW 0x3FFFFUL

#define BITS_PER_BYTE	8
#define PORTB_BYTEs		8
#define PORTC_BYTEs		6
#define PORTD_BYTEs		6



//CHECK PUD = PULLUPDISSABLE in SFIOR 
//PORT B  	//1=OUT 6BIT
//1=OUT
#define PORTB_OUTMASK 			0b111111
#define PORTB_PRESET_PULLMASK	0b000000	//IN beruhigen

//PORT C 	TWI //1=OUT  0 = IN  6BIT
//STARTWERTE
#define PORTC_OUTMASK			0b111111	//ALLES OUT
#define PORTC_PRESET_PULLMASK	0b000000	//

//PORT D	//1=OUT 8 BIT 
#define PORTD_OUTMASK			0xFF	//3 und 4 auf INPUT
#define PORTD_PRESET_PULLMASK	0b000000

//===============================================================================
// STEPMOTORSACHEN
#define FULLSTEPMODEPARSMAX 4	
#define HALFSTEPMODEPARSMAX 8	
//#define QUARTERSTEPMODEPARSMAX 16
//#define EIGHTHSTEPMODEPARSMAX 32
#define MODE_FULLSTEP	1	//Multiplikator 1X. gsStMPar.ucStepMConditionFlag |=  MODE_FULLSTEP
#define MODE_HALFSTEP 	2	//Multiplikator 2X. Set_StepMotor_Mode(gsStMPar.ucStepMConditionFlag & STEPM_STEPMODE_)
#define FULLROT_DEGREE_360			360.0	//muss float sein
#define Motor_START_LAST_BITPATTERN_ON_TIME 15 //~20ms sec ms Zeit, damit der Motor unter vor der Bewegung unter Strom gesetzt wird.
//STEP FRQ
#define FRQ_OFF	0
#define FRQ_ON	1
//DIRECTION
#define SM_DIR_RECHTS	0
#define SM_DIR_LINKS	1

#define PREFDEF_STEPS_PER_ROTATION	200 //DEFAULT, 200 Normal, 400=Fein=0.9Degree, grob=30=~12.857Degree
#define PREDEF_STEPFREQUENZ 			100.0	//Hz
#define PREDEF_RAMPENSSTARTFRQ			10.0	//Die Frq ab der berhaubt erst eine Rampe gefahren wird..
#define PREDEF_RAMP_RISE 				0	//Anstieg der RampenFrequenz
#define PREDEF_STEPRCLOCKS  			1	//STEPS
#define PREDDEF_STEPMODE				MODE_HALFSTEP

//Es wird unterschieden nach CTRL und Condition Flags
//in STRUCT STEPMPARTYPE;
//Flags
#define STEPM_ENABLE_FLAG			0x01	// 0 = OFF
#define STEPM_PULSE_MODE_FLAG		0x02	// 0 = OFF
#define STEPM_RAMPE_FLAG			0x04	// MIT_RAMPE, ?
#define STEPM_START_RAMPE_FLAG		0x08	// 0 = Selected Counts, 1 = Countinous
//------
#define STEPM_STOP_ACTIVE_FLAG		0x10	//STOP, BUT ENABLED, (STROM ON!!) Absicht!!, STEMotor StoptMode ..mit ICTRL, SPTER PWM, oder Automatische Disable nach Timeout.
#define STEPM_TIMEOUT_ENABLE_FLAG	0x20	//After Stop Auto Disable after TIMEOUT
#define STEPM_DIRECTION_FLAG		0x40	// 0 = rechts ?? unbestimmt je nach verdrahtung
#define STEPM_RUN_FLAG				0x80	//Ohne RemainTime Zurcksetzung Run=Continue condtition
//	gsStMPar.ucStepMConditionFlag;	//ISTZUSTAND

#define POSITION_Index_Valid_FLAG			0x01
#define POSITION_LOW_DETECT					0x02
#define POSITION_HIGH_DETECT				0x04
#define POSITION_STOP_ON_TARGET_MODE_FLAG	0x10	
#define POSITION_STOP_ON_TARGET_OK			0x20	
#define POSITION_STOP_ON_DISTANCE_MODE_FLAG	0x40	
#define POSITION_STOP_ON_DISTANCE_OK		0x80	
//gsStMPar.ucSM_PostionFlag

//PORT_ASSIGMNEMTS
//#define ADC_PORT		PORTA
//#define ADC_PORT_MASK 	0xB0 //0100 0000
#define STEPCTRL_PORTX	PORTC //PORTC_OUTMASK
#define STEPCTRL_PINX	PINC
#define STEPAMP_ALLCTRL_MASK	0x3F	//0011 1111
#define STEPAMP_CTRL_MASK		0x0F	//0000 1111
#define STEPAMP_ENABLE_MASK		0x30	//0011 0000
#define STEPAMP_ICTRL_MASK		0x80	//1000 0000
//===============================================================================

// Fernbedienungs-Kommandos:
#define ON_KEY 14
#define OFF_KEY 12
#define RIGHT_KEY 20
#define LEFT_KEY 21
#define FULL_KEY 2
#define HALF_KEY 1
#define ACC_KEY 16
#define DEC_KEY 17
#define REP_KEY 13
//MEINE DEFINTION CHRISTOF
#define STANDBY	12
#define SILENT	13
#define VOLUME_P 		16
#define VOLUME_M 		17
#define BRIGHT_P		18
#define BRIGHT_M		19
#define COLOUR_SATURATION_P	20
#define COLOUR_SATURATION_M	21
#define SEARCH__FORWARD	30
#define SEARCH__BCKWARD	31
#define FAST_BACK	50
#define FAST_FORWARD	52
#define START	53
#define STOP	54
#define RECORD	55


#endif  //MAIN_HEADER
